#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

//
//
//
//
//

extern int    Stochastic.Period1    = 34;
extern int    Ema.Smoothing.Period1 = 5;
extern double Up.Level1             = 80;
extern double Dn.Level1             = 20;

extern int    Stochastic.Period2    = 55;
extern int    Ema.Smoothing.Period2 = 8;
extern double Up.Level2             = 80;
extern double Dn.Level2             = 20;

extern int    Stochastic.Period3    = 100;
extern int    Ema.Smoothing.Period3 = 8;
extern double Up.Level3             = 80;
extern double Dn.Level3             = 20;

extern string __MaFilterEntry       = "Using MA for entries";
extern bool   UseMaForEntry         = false;
extern int    MaPeriod              = 55;
extern int    MaMode                = MODE_SMA;
extern int    MaPrice               = PRICE_CLOSE;

extern string _XOEntry              = "Using XO for entries";
extern bool   UseXoForEntry         = true;
extern int    xotf                  = 0;
extern double BoxPeriod             = 15;

extern string note                  = "turn on Alert = true; turn off = false";
extern bool   alertsOn              = true;
extern bool   alertsOnCurrent       = true;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = true;
extern bool   alertsEmail           = false;
extern string soundfile             = "alert2.wav";
extern int    arrowSize             = 2;
extern double arrowsDisplacement    = 1.0;

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1, CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);  
   SetIndexBuffer(2, trend);
return(0); 
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()
{

return(0);
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {
      double dss1now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period1,Ema.Smoothing.Period1,0,i);
      double dss1pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period1,Ema.Smoothing.Period1,0,i+1);
      double dss2now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period2,Ema.Smoothing.Period2,0,i);
      double dss2pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period2,Ema.Smoothing.Period2,0,i+1);
      double dss3now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period3,Ema.Smoothing.Period3,0,i);
      double dss3pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period3,Ema.Smoothing.Period3,0,i+1);
      double gap     = iATR(NULL,0,20,i); 
      
      //
      //
      //
      //
      //
   
      if (UseMaForEntry)
      {
        bool closeAbove = (Close[i] > iMA(NULL,0,MaPeriod,0,MaMode,MaPrice,i));
        bool closeBelow = (Close[i] < iMA(NULL,0,MaPeriod,0,MaMode,MaPrice,i));
      }
      else      
      {
             closeAbove = true;
             closeBelow = true;
      }
   
      if (UseXoForEntry)
      {
        bool Abovezero = (iCustom(NULL,0,"XO clean",BoxPeriod,0,i) > 0);
        bool Belowzero = (iCustom(NULL,0,"XO clean",BoxPeriod,1,i) < 0);
      }
      else      
      {
             Abovezero = true;
             Belowzero = true;
      }
      
      //
      //
      //
      //
      //
   
      trend[i] = trend[i+1];
      if (Abovezero && closeAbove && dss1now > dss1pre && dss1now < Dn.Level1 && dss2now < Dn.Level2 && dss3now < Dn.Level3) { trend[i] = 1;  }
      if (Belowzero && closeBelow && dss1now < dss1pre && dss1now > Up.Level1 && dss2now > Up.Level2 && dss3now > Up.Level3) { trend[i] =-1;  }  
   
     
      CrossUp[i] = EMPTY_VALUE;
      CrossDn[i] = EMPTY_VALUE;
      if (trend[i] !=trend[i+1])
      if (trend[i] == 1)
            CrossUp[i] = Low[i]  - arrowsDisplacement * gap;
      else  CrossDn[i] = High[i] + arrowsDisplacement * gap; 
        
      }
      
      //
      //
      //
      //
      //
         
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
return(0);
}

//
//
//
//
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DSS Signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DSS Signal "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}